//////////////////////////////////////////////////////////////////////
// Stingray Software - Objective Chart(tm) Copyright (c) 1996 Stingray
// Software Inc. All Rights Reserved. This source code is only
// intended as a supplement to the Stingray Objective Chart product.
// See the help files for detailed information regarding the use of these classes
// Written by Bob Powell (www.stingray.com)
/////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SECComDoc.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// SECComDoc

IMPLEMENT_DYNCREATE(SECComDoc, CDocument)

BEGIN_MESSAGE_MAP(SECComDoc, CDocument)
//{{AFX_MSG_MAP(SECComDoc)
// NOTE - the ClassWizard will add and remove mapping macros here.
//    DO NOT EDIT what you see in these blocks of generated code!
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SECComDoc construction/destruction

// Constructor
SECComDoc::SECComDoc()
{
	m_pParent=NULL;
	m_bUpdatingParent=FALSE;
}

// Destructor. Informs the parent (if any) and all children that this document is being destroyed
SECComDoc::~SECComDoc()
{
	if(m_pParent!=NULL)
		m_pParent->DestroyingDocument(this);
	
	POSITION p;
	for(p=m_DocLinkList.GetHeadPosition();p!=NULL;)
	{
		SECComDoc *doc=(SECComDoc *)m_DocLinkList.GetNext(p);
		doc->Unlink(this);
	}
}

// Creates a new document -- implemented but unchanged for the moment
// TRUE if the document was created.
BOOL SECComDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// SECComDoc serialization

// Handles storage and retrieval of document data
// Reference to the CArchive used to store or retrieve the data
void SECComDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// SECComDoc diagnostics
#ifdef _DEBUG
// DEBUG code
void SECComDoc::AssertValid() const
{
	CDocument::AssertValid();
}

// DEBUG code
void SECComDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// SEC++ Special parameter passing system for clean documents

// When prompted, the document should read data from the memory block obtained from the handle
// UINT  code  User-defined subcode
// HANDLE  hMem  Handle to global memory containing initialization data
// TRUE if the initialization succeeded
BOOL SECComDoc::GmemInit(UINT code,HANDLE hMem)
{
	code; //UNUSED
	ASSERT(FALSE);		// You must decide what to do with the data
	GlobalFree(hMem);	// and then release memory when you have finished with it.
	return FALSE;		// this doc wont work till the override is done
}

// Commands above the reserved threshold (32768) are bumped to this 
// virtual function -- override to handle your own codes
// UINT  nOpCode  Operation code above 32767
// UINT  nSubCode  User-defined code
// UINT  dwData  32 bit data -- may be used to pass pointers, etc.
// TRUE if this command was recognised and processed
BOOL SECComDoc::ProcessUserCommand(UINT nOpCode, UINT nSubCode, UINT dwData)
{
	dwData; //UNUSED
	nSubCode; //UNUSED
	nOpCode; //UNUSED
	ASSERT(FALSE);		// You must decide what to do with the data
	return FALSE;
}

// Processes commands specifically for the SECComDoc implementation<nl>
// Op codes used here may change in subsequent releases.<nl>
// To use your own codes, choose a number above 32767.
// UINT  nOpCode  Operation code below 32767
// UINT  nSubcode  User-defined code
// DWORD  dwData  32 bit data -- may be used to pass pointers, etc.
// TRUE if a document was successfully updated
BOOL SECComDoc::ProcessDocumentCommand(UINT nOpCode, UINT nSubCode, DWORD dwData)
{
	if(nOpCode>=SEC_USER_COMMAND)
		return ProcessUserCommand(nOpCode,nSubCode,dwData); // this gets passed to your overridden function
	
	if(m_bUpdatingParent)
		return TRUE;	// This command may be a result of our own actions. Therefore it
	// should be ignored to avoid a command-loop lockup.
	
	switch(nOpCode)
	{
	case SEC_NOOP:
		return TRUE;
	case SEC_CLIPBOARD_TEXT:
		return ClipboardText();
	case SEC_GMEM_INIT:
		return GmemInit(nSubCode,(HANDLE)dwData); // subcode has the type (eg CF_TEXT) dwData holds a handle to global memory;
	case SEC_DOC_UPDATE:
		return SecDocUpdate(nSubCode,dwData);
	default:
		return FALSE;
	}
}

// Opens a clean document and then runs the requested process
// UINT  nOpCode  Operation code
// UINT  nSubCode  User-defined code
// DWORD  dwData  32 bit data -- may be used to pass pointers, etc.
// TRUE if a document was successfully opened
BOOL SECComDoc::OnOpenDocument(UINT nOpCode, UINT nSubCode, DWORD dwData)
{
	OnNewDocument(); // begin a new document
	return ProcessDocumentCommand(nOpCode,nSubCode,dwData);
}

// Opens a clean document and then runs the requested process
// LPCTSTR  lpszPathName  Filename or operation code and parameters passed as text
// TRUE if a document was successfully opened
BOOL SECComDoc::OnOpenDocument( LPCTSTR lpszPathName)
{
	
	// First if its empty or too small simply call the base class handler
	if(lpszPathName==NULL || (CString(lpszPathName).GetLength()<6))
		return CDocument::OnOpenDocument(lpszPathName);
	
	// if it has a content then strip out the first six letters and compare for the trigger string
	if(CString(lpszPathName,6)==_T("SEC++ "))
	{
		VERIFY(OnNewDocument()); // start a clean document
		// the trigger has been found. Now we decide what to do with it
		int nCode;
		int nPosition;
		if(_stscanf(&lpszPathName[6],_T("%d %n"),&nCode,&nPosition)==1)
		{ // operation code and a current string position index are provided for your own special parsing routines			
			switch(nCode)
			{
			case SEC_CLIPBOARD_TEXT:	// data is text on the clipboard
				ClipboardText();			// do a paste operation to the clean document structure
				break;
			default:	
				ASSERT(FALSE);
				//ASSERT => We dont handle anything else yet!!
				break;
			}
		}
		return TRUE; //although command parsing may have failed there is still a good empty document to use
	}
	else
		return CDocument::OnOpenDocument(lpszPathName);
	
}

// Override of standard MFC code to filter out operation codes passed as text
// LPCTSTR  lpszPathName  Filename or operation code passed as text
// BOOL  bAddToMRU  Flags addition to the most-recently-used list on the main menu
void SECComDoc::SetPathName(LPCTSTR lpszPathName,BOOL bAddToMRU)
{
	// while setting the path name it is important to check for the SEC++ command trigger
	// and remove the initialsation string if it exists
	
	// if its null or too short then just pass it along
	if(lpszPathName==NULL || (CString(lpszPathName).GetLength()<6))
	{
		CDocument::SetPathName(lpszPathName,bAddToMRU);
		return;
	}
	
	// if its one of ours then give it a sensible name
	if(CString(lpszPathName,6)=="SEC++ ")
	{
		CDocTemplate *pDocTemplate=GetDocTemplate();
		pDocTemplate->SetDefaultTitle(this); // by using the default title mechanism
		return;
	}
	
	// none of the above... Pass it along.
	CDocument::SetPathName(lpszPathName,bAddToMRU);
}


/////////////////////////////////////////////////////////////////////////////
// SECComDoc commands

// This function is called when data is on the clipboard.
// Override this virtual function to perform some sensible task in your code. 
// ASSERTS if left alone
// TRUE if the data was processed by the routine
BOOL SECComDoc::ClipboardText(void)
{
	ASSERT(FALSE);
	// ASSERT=> You haven't decided what to do with the data on the clipboard yet!
	// TODO Add your own clipboard text to document conversion routine
	return FALSE; // this routine did not process the data
}

// Initializes a pointer to the document that opened this one
// SECComDoc *  pParent  Pointer to the parent
void SECComDoc::SetParentPointer(SECComDoc* pParent)
{
	m_pParent=pParent; // establishes a line of communication to the parent
}

// Called by the child document to add its own reference to the parent's list of child pointers
// SECComDoc *  newlink  Pointer to the child document being linked
void SECComDoc::NotifyLink(SECComDoc *newlink)
{
	m_DocLinkList.AddTail(newlink);
}

// Called by a parent document to tell a child document that it has grown up or become an orphan
// SECComDoc *  ToUnlink  Pointer to the parent (for verification)
void SECComDoc::Unlink(SECComDoc *ToUnlink)
{	//Search the CPtrList 
	if(ToUnlink==m_pParent) // This should always succeed but it best to be sure.
		m_pParent=NULL;
}

// Informs this document that a child is being destroyed
// SECComDoc *  doc  Pointer to the document currently being destroyed
void SECComDoc::DestroyingDocument(SECComDoc *doc)
{
	POSITION p=m_DocLinkList.Find(doc);
	if(p!=NULL)
		m_DocLinkList.RemoveAt(p);
}

// Called by the parent to update this document
// UINT  nSubCode  Instruction code
// DWORD  dwData  32 bit data
// TRUE to signify successful processing of the information
BOOL SECComDoc::SecDocUpdate(UINT nSubCode, DWORD dwData)
{
	dwData; //UNUSED
	nSubCode; //UNUSED
	ASSERT(FALSE); // Your document class must override this to handle the update
	return FALSE; // data never processed by this function
}

// Walks the list of owned documents and performs an update on each in turn
// UINT  nSubCode  Instruction code
// DWORD  dwData  32 bit data
// TRUE if this function handled the data
BOOL SECComDoc::UpdateLinkedDocuments(UINT nSubCode, DWORD dwData)
{
	POSITION p;
	BOOL Handled=FALSE;
	for(p=m_DocLinkList.GetHeadPosition();p!=NULL;)
	{
		SECComDoc *doc=(SECComDoc *)m_DocLinkList.GetNext(p);
		if(doc->IsKindOf(RUNTIME_CLASS(SECComDoc)))
		{ // just to be sure
			Handled |= doc->ProcessDocumentCommand(SEC_DOC_UPDATE,nSubCode,dwData);
		}
	}
	return Handled;
}


// Returns the number of child documents linked to this document
// Count of the m_DocLinkList member
int SECComDoc::GetLinkCount()
{
	return m_DocLinkList.GetCount();
}

//
// Retrieves a POSITION for the first linked document
// This POSITION may be used with the iteration functions to iterate the linked list.
// <mf SECComDoc::GetNextLink>  <mf SECComDoc::GetPrevLink>
POSITION SECComDoc::GetHeadLinkPosition()
{
	return m_DocLinkList.GetHeadPosition();
}

//
// Retrieves a pointer to the next document in the link list
// POSITION &  pos  Reference to a POSITION obtained from <mf SECComDoc::GetHeadLinkPosition>. 
// This position will be updated by the list iteration routines.
// Pointer to the next child document in the list or NULL if the end of the list has been passed.
// For details of list iteration procedures, see the CObList class in the MFC help file.
SECComDoc * SECComDoc::GetNextLink(POSITION& pos)
{
	return (SECComDoc *)m_DocLinkList.GetNext(pos);
}

//
// Retrieves a pointer to the previous document from the link list
// POSITION &  pos  Reference to a POSITION obtained from <mf SECComDoc::GetHeadLinkPosition>. 
// This position will be updated by the list iteration routines.
// Pointer to the previous child document in the list or NULL if the top of the list has been passed.
// For details of list iteration procedures, see the CObList class in the MFC help file.
SECComDoc * SECComDoc::GetPrevLink(POSITION& pos)
{
	return (SECComDoc *)m_DocLinkList.GetPrev(pos);
}

//
// Allows a child document to update the parent 
// UINT  nSubCode  Command subcode to pass to the parent
// DWORD  dwData  Data item to be passed to the parent
// Returns the result of the parent's document command processing or FALSE if this document has no parent
BOOL SECComDoc::UpdateParentDocument(UINT nSubCode,DWORD dwData)
{
	m_bUpdatingParent=TRUE;
	
	BOOL bRval=FALSE;
	
	if(m_pParent!=NULL)
	{
		ASSERT(m_pParent->IsKindOf(RUNTIME_CLASS(SECComDoc))); // There is no reason that it should'nt be!!
		bRval=m_pParent->ProcessDocumentCommand(SEC_DOC_UPDATE,nSubCode,dwData);
	}
	m_bUpdatingParent=FALSE;
	return bRval;
}
